--require ("util")

data:extend(
{
   {
    type = "explosion",
    name = "worm-rumble-small",
    flags = {"not-on-map"},
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound = make_worm_dying_sounds(0.1),
  },
  {
    type = "explosion",
    name = "worm-rumble-medium",
    flags = {"not-on-map"},
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound = make_worm_dying_sounds(0.2),
  },
  {
    type = "explosion",
    name = "worm-rumble-large",
    flags = {"not-on-map"},
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound = make_worm_dying_sounds(0.3),
  },
  {
    type = "decorative",
    name = "behemoth-worm-burrowing",
	icon = "__WormAttack__/graphics/blank.png",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    order = "x[burrowworm] a",
	pictures =
    {
		{
			filename = "__WormAttack__/graphics/blank.png",
			width = 100,
			height = 100,
		},
	}
  },
  {
    type = "decorative",
    name = "colossal-worm-burrowing",
	icon = "__WormAttack__/graphics/blank.png",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    order = "x[burrowworm] b",
	pictures =
    {
		{
			filename = "__WormAttack__/graphics/blank.png",
			width = 100,
			height = 100,
		},
	}
  },
  {
    type = "decorative",
    name = "behemoth-worm-attacking",
	icon = "__WormAttack__/graphics/blank.png",
    flags = {"placeable-neutral","player-creation", "placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    order = "y[attackworm] a",
	pictures =
    {
		{
			filename = "__WormAttack__/graphics/blank.png",
			width = 100,
			height = 100,
		},
	}
  },
  {
    type = "decorative",
    name = "colossal-worm-attacking",
	icon = "__WormAttack__/graphics/blank.png",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    order = "y[attackworm] b",
	pictures =
    {
		{
			filename = "__WormAttack__/graphics/blank.png",
			width = 100,
			height = 100,
		},
	}
  },
  {
    type = "explosion",
    name = "behemoth-worm-surfacing",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 1, size = 50},
    sound =
    {
      aggregation =
      {
        max_count = 1,
        remove = true
      },
      variations =
      {
        {
          filename = "__base__/sound/fight/large-explosion-1.ogg",
          volume = 1.25
        },
        {
          filename = "__base__/sound/fight/large-explosion-2.ogg",
          volume = 1.25
        }
      }
    },
    created_effect =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-particle",
            repeat_count = 60,
            entity_name = "explosion-remnants-particle",
            initial_height = 0.5,
            speed_from_center = 0.08,
            speed_from_center_deviation = 0.15,
            initial_vertical_speed = 0.08,
            initial_vertical_speed_deviation = 0.15,
            offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
          }
        }
      }
    }
  },
  {
    type = "explosion",
    name = "behemoth-worm-breakthrough",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound =
    {
      aggregation =
      {
        max_count = 1,
        remove = true
      },
      variations =
      {
        {
          filename = "__base__/sound/fight/large-explosion-1.ogg",
          volume = 1.25
        },
        {
          filename = "__base__/sound/fight/large-explosion-2.ogg",
          volume = 1.25
        }
      }
    },
    created_effect =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-particle",
            repeat_count = 60,
            entity_name = "explosion-remnants-particle",
            initial_height = 0.5,
            speed_from_center = 0.08,
            speed_from_center_deviation = 0.15,
            initial_vertical_speed = 0.08,
            initial_vertical_speed_deviation = 0.15,
            offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              perimeter = 6,
              action_delivery =
              {
                type = "instant",
                target_effects =
                {
                  type = "damage",
                  damage = { amount = 50, type = "explosion"}
                }
              }
            },
          }        
		}
      }
    }
  },
  {
    type = "explosion",
    name = "behemoth-worm-surface",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound =
    {
      aggregation =
      {
        max_count = 1,
        remove = true
      },
      variations =
      {
        {
          filename = "__base__/sound/fight/large-explosion-1.ogg",
          volume = 1.25
        },
        {
          filename = "__base__/sound/fight/large-explosion-2.ogg",
          volume = 1.25
        }
      }
    },
    created_effect =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-particle",
            repeat_count = 60,
            entity_name = "explosion-remnants-particle",
            initial_height = 0.5,
            speed_from_center = 0.08,
            speed_from_center_deviation = 0.15,
            initial_vertical_speed = 0.08,
            initial_vertical_speed_deviation = 0.15,
            offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
          }        
  	    }
      }
    }
  },
  {
    type = "explosion",
    name = "colossal-worm-breakthrough",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound =
    {
      aggregation =
      {
        max_count = 1,
        remove = true
      },
      variations =
      {
        {
          filename = "__base__/sound/fight/large-explosion-1.ogg",
          volume = 1.5
        },
        {
          filename = "__base__/sound/fight/large-explosion-2.ogg",
          volume = 1.5
        }
      }
    },
    created_effect =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-particle",
            repeat_count = 80,
            entity_name = "explosion-remnants-particle",
            initial_height = 0.5,
            speed_from_center = 0.08,
            speed_from_center_deviation = 0.15,
            initial_vertical_speed = 0.08,
            initial_vertical_speed_deviation = 0.15,
            offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              perimeter = 8,
              action_delivery =
              {
                type = "instant",
                target_effects =
                {
                  type = "damage",
                  damage = { amount = 100, type = "explosion"}
                }
              }
            },
          }        
		}
      }
    }
  },
  {
    type = "explosion",
    name = "colossal-worm-surface",
    flags = {"placeable-off-grid", "not-on-map"},
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{0, 0}, {0, 0}},
    collision_mask = { "item-layer" },
    selectable_in_game = false,
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound =
    {
      aggregation =
      {
        max_count = 1,
        remove = true
      },
      variations =
      {
        {
          filename = "__base__/sound/fight/large-explosion-1.ogg",
          volume = 1.5
        },
        {
          filename = "__base__/sound/fight/large-explosion-2.ogg",
          volume = 1.5
        }
      }
    },
    created_effect =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "create-particle",
            repeat_count = 80,
            entity_name = "explosion-remnants-particle",
            initial_height = 0.5,
            speed_from_center = 0.08,
            speed_from_center_deviation = 0.15,
            initial_vertical_speed = 0.08,
            initial_vertical_speed_deviation = 0.15,
            offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
          }        
  	    }
      }
    }
  },
  {
    type = "corpse",
    name = "medium-acid-splatter-purple",
    flags = {"not-on-map"},
    time_before_removed = 60 * 30,
    final_render_layer = "corpse",
    splash =
    {
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-1.png",
        line_length = 5,
        width = 199,
        height = 159,
        frame_count = 20,
		scale = 3,
        shift = {0.484375*3, -0.171875*3},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-2.png",
        line_length = 5,
        width = 238,
        height = 157,
        frame_count = 20,
		scale = 3,
        shift = {0.8125*3, -0.15625*3},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-3.png",
        line_length = 5,
        width = 240,
        height = 162,
        frame_count = 20,
		scale = 3,
        shift = {0.71875*3, -0.09375*3},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-4.png",
        line_length = 5,
        width = 241,
        height = 146,
        frame_count = 20,
		scale = 3,
        shift = {0.703125*3, -0.375*3},
      }
    },
    splash_speed = 0.02
  },
  {
    type = "corpse",
    name = "huge-acid-splatter-purple",
    flags = {"not-on-map"},
    time_before_removed = 60 * 45,
    final_render_layer = "corpse",
    splash =
    {
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-1.png",
        line_length = 5,
        width = 199,
        height = 159,
        frame_count = 20,
		scale = 4,
        shift = {0.484375*4, -0.171875*4},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-2.png",
        line_length = 5,
        width = 238,
        height = 157,
        frame_count = 20,
		scale = 4,
        shift = {0.8125*4, -0.15625*4},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-3.png",
        line_length = 5,
        width = 240,
        height = 162,
        frame_count = 20,
		scale = 4,
        shift = {0.71875*4, -0.09375*4},
      },
      {
        filename = "__base__/graphics/entity/acid-splash-purple/splash-4.png",
        line_length = 5,
        width = 241,
        height = 146,
        frame_count = 20,
		scale = 4,
        shift = {0.703125*4, -0.375*4},
      }
    },
    splash_speed = 0.02
  },
  {
    type = "explosion",
    name = "worm-dying-underground",
    flags = {"not-on-map"},
    animations =
    {
      {
		filename = "__WormAttack__/graphics/blank.png",
		width = 100,
		height = 100,
		frame_count = 1,
		line_length = 1,
		shift = {0, 0}
      }
    },
    light = {intensity = 0, size = 0},
    sound = make_worm_dying_sounds(1.0),
  },
}
)
